{
-----------------------------------------------------------------
 TpbhStatusBar version 1.0.0

 A pure VCL statusbar with additional panel features
-----------------------------------------------------------------

  Copyright (C) 2001 by Peter B. Hedlund
  All rights reserved.
  http://peterandlinda.com/components/
  support@peterandlinda.com

  All contents of this file and all other files included in the
  pbhStatusbar package are copyright (C) 2001 Peter B. Hedlund and
  shall remain the exclusive property of the author.

  Use and/or distribution of them requires acceptance of the
  following terms.

  "Author" herein refers to Peter B. Hedlund (the creator of the
  pbhStatusbar component).
  "Software" refers to all files bearing this notice, as well as
  any other files and source code included with pbhStatusbar
  (typically part of a .zip archive), and all content in them,
  regardless of whether any modifications have been made.

  1) This notice may not be removed from or altered in any source
     distribution.

  2) The Software may only be redistributed in the original
     archive form with all files included and unmodified.

  3) You are permitted to compile the Software into any kind of
     applications. ("Compile" refers to the automatic process of
     translating the Software's source code into executable Intel
     x86 machine code by the Borland Delphi or C++Builder
     compilers.)

  4) This software is provided "as-is", without any express or
     implied warranty. In no event shall the Author be held liable
     for any damages arising from the use of this software.

  5) Full backward compatibility in future versions of the Software
     is not guaranteed. In no event shall the Author be held liable
     for any inconvenience or damages arising from lack of backward
     compatibility.

  6) The Author may terminate your rights to use the Software for
     any reason at his sole discretion.

  7) If you do not agree to any of these terms, you are not
     permitted to use the Software in any way, and all copies of
     it must be deleted from your system(s).

------------------------------------------------------------------------------
 Date last modified:  November 27, 2000
------------------------------------------------------------------------------
}


unit pbhStatusDemoForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  pbhStatusBar, ComCtrls, StdCtrls, ImgList, ExtCtrls, Grids, Menus;

type
  TForm1 = class(TForm)
    pbhStatusBar1: TpbhStatusBar;
    ImageList1: TImageList;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    N1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    N2: TMenuItem;
    Print1: TMenuItem;
    N3: TMenuItem;
    Exit1: TMenuItem;
    grpSecondPanel: TGroupBox;
    chkFit: TCheckBox;
    Edit1: TEdit;
    Button2: TButton;
    lstAlign: TListBox;
    lstBorder: TListBox;
    lstColor: TListBox;
    grpStatusbar: TGroupBox;
    chkSimpleMode: TCheckBox;
    chkSizeGrip: TCheckBox;
    txtSimpleMode: TEdit;
    grpFirstPanel: TGroupBox;
    chkSpring: TCheckBox;
    grpThirdPanel: TGroupBox;
    chkCustomHint: TCheckBox;
    txtCustomHint: TEdit;
    grpTry: TGroupBox;
    Label1: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure chkSimpleModeClick(Sender: TObject);
    procedure txtSimpleModeChange(Sender: TObject);
    procedure chkFitClick(Sender: TObject);
    procedure chkSizeGripClick(Sender: TObject);
    procedure pbhStatusBar1Hint(Sender: TObject);
    procedure pbhStatusBar1DrawPanel(StatusBar: TpbhStatusBar;
      Canvas: TCanvas; Panel: TpbhStatusPanel; const Rect: TRect);
    procedure pbhStatusBar1Panels1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure chkSpringClick(Sender: TObject);
    procedure pbhStatusBar1Panels2DblClick(Sender: TObject);
    procedure pbhStatusBar1Panels2Hint(Sender: TObject);
    procedure lstAlignClick(Sender: TObject);
    procedure lstBorderClick(Sender: TObject);
    procedure lstColorClick(Sender: TObject);
  private
    { Private declarations }
    procedure HintProc(Sender: TObject);
    procedure IdleProc(Sender: TObject; var Done: Boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button2Click(Sender: TObject);
begin
  pbhStatusbar1.Panels[1].Width := StrToInt(Edit1.Text);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Label1.Caption := 'Check menu hints' + Chr(10) + Chr(13) +
    'Click on the second panel' + Chr(10) + Chr(13) +
    'Double click on the third panel' + Chr(10) + Chr(13) +
    'Each panel has its own hint';
  chkSizegrip.Checked := pbhStatusBar1.SizeGrip;
  Application.OnHint := HintProc;
  Application.OnIdle := IdleProc;
  lstAlign.ItemIndex := 0;
  lstBorder.ItemIndex := 2;
  lstColor.ItemIndex := 0;
end;

procedure TForm1.chkSimpleModeClick(Sender: TObject);
begin
  pbhStatusBar1.SimplePanel := chkSimpleMode.Checked;
end;

procedure TForm1.txtSimpleModeChange(Sender: TObject);
begin
  pbhStatusBar1.SimpleText := txtSimpleMode.Text;
end;

procedure TForm1.chkFitClick(Sender: TObject);
begin
  pbhStatusbar1.Panels[1].FitToContent := chkFit.Checked;
end;

procedure TForm1.chkSizeGripClick(Sender: TObject);
begin
  pbhStatusBar1.SizeGrip := chkSizeGrip.Checked;
end;

procedure TForm1.pbhStatusBar1Hint(Sender: TObject);
begin
  pbhStatusbar1.Hint := 'Simple Panel Hint';
end;

procedure TForm1.pbhStatusBar1DrawPanel(StatusBar: TpbhStatusBar;
  Canvas: TCanvas; Panel: TpbhStatusPanel; const Rect: TRect);
begin
  if Panel = pbhStatusbar1.Panels[1] then begin
    Canvas.Brush.Color := clGreen;
    Canvas.Fillrect(Rect);
  end;
end;

procedure TForm1.pbhStatusBar1Panels1Click(Sender: TObject);
begin
  ShowMessage('You clicked the second panel');
end;

procedure TForm1.HintProc(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to File1.Count - 1 do
    if Application.Hint = File1[i].Hint then begin
      if pbhStatusbar1.SimplePanel then
        pbhStatusbar1.SimpleText := File1[i].Hint
      else begin
        pbhStatusbar1.Panels[0].ImageIndex := File1[i].ImageIndex;
        pbhStatusbar1.Panels[0].Text := File1[i].Hint;
      end;
      Exit;
    end;

  pbhStatusbar1.Panels[0].ImageIndex := -1;
  pbhStatusbar1.Panels[0].Text := Application.Hint;
  // pbhStatusbar1.Panels[0].Text := 'Menu hint panel';

end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.chkSpringClick(Sender: TObject);
begin
  pbhStatusbar1.Panels[0].Spring := chkSpring.Checked;
end;

procedure TForm1.pbhStatusBar1Panels2DblClick(Sender: TObject);
begin
  ShowMessage('You double clicked the third panel');
end;

procedure TForm1.pbhStatusBar1Panels2Hint(Sender: TObject);
begin
  if chkCustomHint.Checked then
    pbhStatusbar1.Panels[2].Hint := txtCustomHint.Text
  else
    pbhStatusbar1.Panels[2].Hint := 'Custom Hint';
end;

procedure TForm1.lstAlignClick(Sender: TObject);
begin
  case lstAlign.ItemIndex of
    0: pbhStatusBar1.Panels[1].Alignment := taLeftJustify;
    1: pbhStatusBar1.Panels[1].Alignment := taRightJustify;
    2: pbhStatusBar1.Panels[1].Alignment := taCenter;
  end;
end;

procedure TForm1.lstBorderClick(Sender: TObject);
begin
  case lstBorder.ItemIndex of
    0: pbhStatusBar1.Panels[1].Bevel := pbsNoBorder;
    1: pbhStatusBar1.Panels[1].Bevel := pbsFlatBorder;
    2: pbhStatusBar1.Panels[1].Bevel := pbsSunkenBorder;
    3: pbhStatusBar1.Panels[1].Bevel := pbsRaisedBorder;
  end;
end;

procedure TForm1.lstColorClick(Sender: TObject);
begin
  begin
    case lstColor.ItemIndex of
      0:
        begin
          pbhStatusBar1.Panels[1].Colors.BackColor := clBtnFace;
          pbhStatusBar1.Panels[1].Colors.FlatBorderColor := clBtnHighlight;
          pbhStatusBar1.Panels[1].Colors.BorderHighlightColor := clBtnHighlight;
          pbhStatusBar1.Panels[1].Colors.BorderShadowColor := clBtnShadow;
        end;
      1:
        begin
          pbhStatusBar1.Panels[1].Colors.BackColor := clBlue;
          pbhStatusBar1.Panels[1].Colors.FlatBorderColor := clAqua;
          pbhStatusBar1.Panels[1].Colors.BorderHighlightColor := clAqua;
          pbhStatusBar1.Panels[1].Colors.BorderShadowColor := clNavy;
        end;

      2:
        begin
          pbhStatusBar1.Panels[1].Colors.BackColor := clRed;
          pbhStatusBar1.Panels[1].Colors.FlatBorderColor := clFuchsia;
          pbhStatusBar1.Panels[1].Colors.BorderHighlightColor := clFuchsia;
          pbhStatusBar1.Panels[1].Colors.BorderShadowColor := clMaroon;
        end;


    end;
  end;
end;

procedure TForm1.IdleProc(Sender: TObject; var Done: Boolean);
begin
  pbhStatusBar1.Panels[0].ImageIndex := -1;
  pbhStatusBar1.Panels[0].Text := 'Ready';
end;

end.

